%we can allow more error margins
error(0.5).

%dist/4 definition used for hypothesis generation
dist(Coord1, Coord2, Dist, Error):-
  Coord1\=Coord2,
  var(Dist), !,
  euc_dist(Coord1, Coord2, Dist1),
  Dist is truncate(Dist1*10)/10,%to get just 1 decimal place
  error(Error).
%dist/4 definition used for coverage testing when Dist is ground
dist(Coord1, Coord2, Dist, Error):-
  number(Dist),
  euc_dist(Coord1, Coord2, Dist1),
  abs(Dist1 - Dist) =< Error.

%euc_dist(+Coord1, +Coord2, -Distance)
euc_dist(coord(X1,Y1,Z1),coord(X2,Y2,Z2), Dist):-
  Dist is sqrt((X1 - X2)^2 + (Y1 - Y2)^2 + (Z1 - Z2)^2).

gteq(X,X):- !.
gteq(X,Y):- X > Y.

lteq(X,X):- !.
lteq(X,Y):- X < Y.
