:- set(i,4).

:- set(clauselength,6).

:- modeh(1, bind(+pdb)).

%note: aminoacid_id is a single aminoacid identifier that is unique across all pdbs
:- modeb(7, has_aminoacid(+pdb, -aminoacid_id, #aminoacid_name)).
:- modeb(1, diff_aminoacid(+aminoacid_id, +aminoacid_id)).
:- modeb(7, atom_to_center_dist(+aminoacid_id, #atom_name, #dist, #error)).
:- modeb(7, atom_to_atom_dist(+aminoacid_id, +aminoacid_id, #atom_name, #atom_name, #dist, #error)).

:- commutative(diff_aminoacid/2).
:- commutative(atom_to_atom_dist/6).
:- determination(bind/1, has_aminoacid/3).
:- determination(bind/1, diff_aminoacid/2).
:- determination(bind/1, atom_to_center_dist/4).
:- determination(bind/1, atom_to_atom_dist/6).


%atom_to_center_dist(+aminoacid_id, #atom_name, #dist, #error)
atom_to_center_dist(Aminoacid_id, Atom_name, Dist, Tolerance):-
  has_aminoacid(PDB, Aminoacid_id, _),
  has_atom(Aminoacid_id, Atom_name, Coords1),
  center_coords(PDB, Coords2),
  dist(Coords1, Coords2, Dist, Tolerance).

%atom_to_atom_dist(+aminoacid_id, +aminoacid_id, #atom_name, #atom_name, #dist, #error)
atom_to_atom_dist(Aminoacid_id1, Aminoacid_id2, Atom_name1, Atom_name2, Dist, Tolerance):-
  %Aminoacid_id1\=Aminoacid_id2,
  has_aminoacid(PDB, Aminoacid_id1, _),
  has_atom(Aminoacid_id1, Atom_name1, Coords1),
  has_aminoacid(PDB, Aminoacid_id2, _),
  has_atom(Aminoacid_id2, Atom_name2, Coords2),
  dist(Coords1, Coords2, Dist, Tolerance).

%:- [aminoacids].      % includes: has_aminoacid/2
:- [aminoacids3].     % includes: has_aminoacid/3
%:- [amin_names].      % includes: aminoacid_name/2
%:- [amin_properties]. % includes: aminoacid_polarity/2, aminoacid_charge/2, aminoacid_hydropathy/2
:- [atoms].           % includes: has_atom/3
:- ['../common/center_coords'].   % includes: center_coords/2
:- ['../common/dist'].      % includes: dist/4, gteq/2, lteq/2

diff_aminoacid(A, B):-
  A\=B.
